package com.sun.org.apache.xalan.internal.xsltc.dom;

import com.sun.org.apache.xml.internal.dtm.ref.DTMAxisIteratorBase;
import com.sun.org.apache.xml.internal.dtm.DTMManager;
import javax.xml.transform.SourceLocator;
import org.xml.sax.ext.DeclHandler;
import org.xml.sax.ErrorHandler;
import org.xml.sax.DTDHandler;
import org.xml.sax.EntityResolver;
import org.xml.sax.ext.LexicalHandler;
import org.xml.sax.ContentHandler;
import com.sun.org.apache.xml.internal.utils.XMLStringDefault;
import com.sun.org.apache.xml.internal.utils.XMLString;
import com.sun.org.apache.xml.internal.dtm.DTMAxisTraverser;
import java.util.Map;
import com.sun.org.apache.xalan.internal.xsltc.StripFilter;
import org.w3c.dom.NodeList;
import org.w3c.dom.Node;
import org.xml.sax.SAXException;
import com.sun.org.apache.xalan.internal.xsltc.TransletException;
import com.sun.org.apache.xml.internal.serializer.SerializationHandler;
import com.sun.org.apache.xml.internal.dtm.ref.DTMManagerDefault;
import com.sun.org.apache.xml.internal.dtm.DTMAxisIterator;
import com.sun.org.apache.xml.internal.dtm.DTM;
import com.sun.org.apache.xalan.internal.xsltc.DOM;
import com.sun.org.apache.xml.internal.serializer.EmptySerializer;

public class SimpleResultTreeImpl extends EmptySerializer implements DOM, DTM
{
    private static final DTMAxisIterator EMPTY_ITERATOR;
    public static final int RTF_ROOT = 0;
    public static final int RTF_TEXT = 1;
    public static final int NUMBER_OF_NODES = 2;
    private static int _documentURIIndex;
    private static final String EMPTY_STR = "";
    private String _text;
    protected String[] _textArray;
    protected XSLTCDTMManager _dtmManager;
    protected int _size;
    private int _documentID;
    private BitArray _dontEscape;
    private boolean _escaping;
    
    public SimpleResultTreeImpl(XSLTCDTMManager dtmManager, int documentID) {
        this._size = 0;
        this._dontEscape = null;
        this._escaping = true;
        this._dtmManager = dtmManager;
        this._documentID = documentID;
        this._textArray = new String[4];
    }
    
    public DTMManagerDefault getDTMManager() {
        return this._dtmManager;
    }
    
    @Override
    public int getDocument() {
        return this._documentID;
    }
    
    @Override
    public String getStringValue() {
        return this._text;
    }
    
    @Override
    public DTMAxisIterator getIterator() {
        return new SimpleResultTreeImpl.SingletonIterator(this.getDocument());
    }
    
    @Override
    public DTMAxisIterator getChildren(int node) {
        return new SimpleResultTreeImpl.SimpleIterator().setStartNode(node);
    }
    
    @Override
    public DTMAxisIterator getTypedChildren(int type) {
        return new SimpleResultTreeImpl.SimpleIterator(1, type);
    }
    
    @Override
    public DTMAxisIterator getAxisIterator(int axis) {
        switch (axis) {
            case 3:
            case 4: {
                return new SimpleResultTreeImpl.SimpleIterator(1);
            }
            case 0:
            case 10: {
                return new SimpleResultTreeImpl.SimpleIterator(0);
            }
            case 1: {
                return new SimpleResultTreeImpl.SimpleIterator(0).includeSelf();
            }
            case 5: {
                return new SimpleResultTreeImpl.SimpleIterator(1).includeSelf();
            }
            case 13: {
                return new SimpleResultTreeImpl.SingletonIterator();
            }
            default: {
                return SimpleResultTreeImpl.EMPTY_ITERATOR;
            }
        }
    }
    
    @Override
    public DTMAxisIterator getTypedAxisIterator(int axis, int type) {
        switch (axis) {
            case 3:
            case 4: {
                return new SimpleResultTreeImpl.SimpleIterator(1, type);
            }
            case 0:
            case 10: {
                return new SimpleResultTreeImpl.SimpleIterator(0, type);
            }
            case 1: {
                return new SimpleResultTreeImpl.SimpleIterator(0, type).includeSelf();
            }
            case 5: {
                return new SimpleResultTreeImpl.SimpleIterator(1, type).includeSelf();
            }
            case 13: {
                return new SimpleResultTreeImpl.SingletonIterator(type);
            }
            default: {
                return SimpleResultTreeImpl.EMPTY_ITERATOR;
            }
        }
    }
    
    @Override
    public DTMAxisIterator getNthDescendant(int node, int n, boolean includeself) {
        return null;
    }
    
    @Override
    public DTMAxisIterator getNamespaceAxisIterator(int axis, int ns) {
        return null;
    }
    
    @Override
    public DTMAxisIterator getNodeValueIterator(DTMAxisIterator iter, int returnType, String value, boolean op) {
        return null;
    }
    
    @Override
    public DTMAxisIterator orderNodes(DTMAxisIterator source, int node) {
        return source;
    }
    
    @Override
    public String getNodeName(int node) {
        if (this.getNodeIdent(node) == 1) {
            return "#text";
        }
        return "";
    }
    
    @Override
    public String getNodeNameX(int node) {
        return "";
    }
    
    @Override
    public String getNamespaceName(int node) {
        return "";
    }
    
    @Override
    public int getExpandedTypeID(int nodeHandle) {
        int nodeID = this.getNodeIdent(nodeHandle);
        if (nodeID == 1) {
            return 3;
        }
        if (nodeID == 0) {
            return 0;
        }
        return -1;
    }
    
    @Override
    public int getNamespaceType(int node) {
        return 0;
    }
    
    @Override
    public int getParent(int nodeHandle) {
        int nodeID = this.getNodeIdent(nodeHandle);
        return (nodeID == 1) ? this.getNodeHandle(0) : -1;
    }
    
    @Override
    public int getAttributeNode(int gType, int element) {
        return -1;
    }
    
    @Override
    public String getStringValueX(int nodeHandle) {
        int nodeID = this.getNodeIdent(nodeHandle);
        if (nodeID == 0 || nodeID == 1) {
            return this._text;
        }
        return "";
    }
    
    @Override
    public void copy(int node, SerializationHandler handler) throws TransletException {
        this.characters(node, handler);
    }
    
    @Override
    public void copy(DTMAxisIterator nodes, SerializationHandler handler) throws TransletException {
        int node;
        while ((node = nodes.next()) != -1) {
            this.copy(node, handler);
        }
    }
    
    @Override
    public String shallowCopy(int node, SerializationHandler handler) throws TransletException {
        this.characters(node, handler);
        return null;
    }
    
    @Override
    public boolean lessThan(int node1, int node2) {
        return node1 != -1 && (node2 == -1 || node1 < node2);
    }
    
    @Override
    public void characters(int node, SerializationHandler handler) throws TransletException {
        int nodeID = this.getNodeIdent(node);
        if (nodeID == 0 || nodeID == 1) {
            boolean escapeBit = false;
            boolean oldEscapeSetting = false;
            try {
                for (int i = 0; i < this._size; ++i) {
                    if (this._dontEscape != null) {
                        escapeBit = this._dontEscape.getBit(i);
                        if (escapeBit) {
                            oldEscapeSetting = handler.setEscaping(false);
                        }
                    }
                    handler.characters(this._textArray[i]);
                    if (escapeBit) {
                        handler.setEscaping(oldEscapeSetting);
                    }
                }
            }
            catch (SAXException e) {
                throw new TransletException(e);
            }
        }
    }
    
    @Override
    public Node makeNode(int index) {
        return null;
    }
    
    @Override
    public Node makeNode(DTMAxisIterator iter) {
        return null;
    }
    
    @Override
    public NodeList makeNodeList(int index) {
        return null;
    }
    
    @Override
    public NodeList makeNodeList(DTMAxisIterator iter) {
        return null;
    }
    
    @Override
    public String getLanguage(int node) {
        return null;
    }
    
    @Override
    public int getSize() {
        return 2;
    }
    
    @Override
    public String getDocumentURI(int node) {
        return "simple_rtf" + SimpleResultTreeImpl._documentURIIndex++;
    }
    
    @Override
    public void setFilter(StripFilter filter) {
    }
    
    @Override
    public void setupMapping(String[] names, String[] uris, int[] types, String[] namespaces) {
    }
    
    @Override
    public boolean isElement(int node) {
        return false;
    }
    
    @Override
    public boolean isAttribute(int node) {
        return false;
    }
    
    @Override
    public String lookupNamespace(int node, String prefix) throws TransletException {
        return null;
    }
    
    @Override
    public int getNodeIdent(int nodehandle) {
        return (nodehandle != -1) ? (nodehandle - this._documentID) : -1;
    }
    
    @Override
    public int getNodeHandle(int nodeId) {
        return (nodeId != -1) ? (nodeId + this._documentID) : -1;
    }
    
    @Override
    public DOM getResultTreeFrag(int initialSize, int rtfType) {
        return null;
    }
    
    @Override
    public DOM getResultTreeFrag(int initialSize, int rtfType, boolean addToManager) {
        return null;
    }
    
    @Override
    public SerializationHandler getOutputDomBuilder() {
        return this;
    }
    
    @Override
    public int getNSType(int node) {
        return 0;
    }
    
    @Override
    public String getUnparsedEntityURI(String name) {
        return null;
    }
    
    @Override
    public Map<String, Integer> getElementsWithIDs() {
        return null;
    }
    
    @Override
    public void startDocument() throws SAXException {
    }
    
    @Override
    public void endDocument() throws SAXException {
        if (this._size == 1) {
            this._text = this._textArray[0];
        }
        else {
            StringBuffer buffer = new StringBuffer();
            for (int i = 0; i < this._size; ++i) {
                buffer.append(this._textArray[i]);
            }
            this._text = buffer.toString();
        }
    }
    
    @Override
    public void characters(String str) throws SAXException {
        if (this._size >= this._textArray.length) {
            String[] newTextArray = new String[this._textArray.length * 2];
            System.arraycopy(this._textArray, 0, newTextArray, 0, this._textArray.length);
            this._textArray = newTextArray;
        }
        if (!this._escaping) {
            if (this._dontEscape == null) {
                this._dontEscape = new BitArray(8);
            }
            if (this._size >= this._dontEscape.size()) {
                this._dontEscape.resize(this._dontEscape.size() * 2);
            }
            this._dontEscape.setBit(this._size);
        }
        this._textArray[this._size++] = str;
    }
    
    @Override
    public void characters(char[] ch, int offset, int length) throws SAXException {
        if (this._size >= this._textArray.length) {
            String[] newTextArray = new String[this._textArray.length * 2];
            System.arraycopy(this._textArray, 0, newTextArray, 0, this._textArray.length);
            this._textArray = newTextArray;
        }
        if (!this._escaping) {
            if (this._dontEscape == null) {
                this._dontEscape = new BitArray(8);
            }
            if (this._size >= this._dontEscape.size()) {
                this._dontEscape.resize(this._dontEscape.size() * 2);
            }
            this._dontEscape.setBit(this._size);
        }
        this._textArray[this._size++] = new String(ch, offset, length);
    }
    
    @Override
    public boolean setEscaping(boolean escape) throws SAXException {
        boolean temp = this._escaping;
        this._escaping = escape;
        return temp;
    }
    
    @Override
    public void setFeature(String featureId, boolean state) {
    }
    
    @Override
    public void setProperty(String property, Object value) {
    }
    
    @Override
    public DTMAxisTraverser getAxisTraverser(int axis) {
        return null;
    }
    
    @Override
    public boolean hasChildNodes(int nodeHandle) {
        return this.getNodeIdent(nodeHandle) == 0;
    }
    
    @Override
    public int getFirstChild(int nodeHandle) {
        int nodeID = this.getNodeIdent(nodeHandle);
        if (nodeID == 0) {
            return this.getNodeHandle(1);
        }
        return -1;
    }
    
    @Override
    public int getLastChild(int nodeHandle) {
        return this.getFirstChild(nodeHandle);
    }
    
    @Override
    public int getAttributeNode(int elementHandle, String namespaceURI, String name) {
        return -1;
    }
    
    @Override
    public int getFirstAttribute(int nodeHandle) {
        return -1;
    }
    
    @Override
    public int getFirstNamespaceNode(int nodeHandle, boolean inScope) {
        return -1;
    }
    
    @Override
    public int getNextSibling(int nodeHandle) {
        return -1;
    }
    
    @Override
    public int getPreviousSibling(int nodeHandle) {
        return -1;
    }
    
    @Override
    public int getNextAttribute(int nodeHandle) {
        return -1;
    }
    
    @Override
    public int getNextNamespaceNode(int baseHandle, int namespaceHandle, boolean inScope) {
        return -1;
    }
    
    @Override
    public int getOwnerDocument(int nodeHandle) {
        return this.getDocument();
    }
    
    @Override
    public int getDocumentRoot(int nodeHandle) {
        return this.getDocument();
    }
    
    @Override
    public XMLString getStringValue(int nodeHandle) {
        return new XMLStringDefault(this.getStringValueX(nodeHandle));
    }
    
    @Override
    public int getStringValueChunkCount(int nodeHandle) {
        return 0;
    }
    
    @Override
    public char[] getStringValueChunk(int nodeHandle, int chunkIndex, int[] startAndLen) {
        return null;
    }
    
    @Override
    public int getExpandedTypeID(String namespace, String localName, int type) {
        return -1;
    }
    
    @Override
    public String getLocalNameFromExpandedNameID(int ExpandedNameID) {
        return "";
    }
    
    @Override
    public String getNamespaceFromExpandedNameID(int ExpandedNameID) {
        return "";
    }
    
    @Override
    public String getLocalName(int nodeHandle) {
        return "";
    }
    
    @Override
    public String getPrefix(int nodeHandle) {
        return null;
    }
    
    @Override
    public String getNamespaceURI(int nodeHandle) {
        return "";
    }
    
    @Override
    public String getNodeValue(int nodeHandle) {
        return (this.getNodeIdent(nodeHandle) == 1) ? this._text : null;
    }
    
    @Override
    public short getNodeType(int nodeHandle) {
        int nodeID = this.getNodeIdent(nodeHandle);
        if (nodeID == 1) {
            return 3;
        }
        if (nodeID == 0) {
            return 0;
        }
        return -1;
    }
    
    @Override
    public short getLevel(int nodeHandle) {
        int nodeID = this.getNodeIdent(nodeHandle);
        if (nodeID == 1) {
            return 2;
        }
        if (nodeID == 0) {
            return 1;
        }
        return -1;
    }
    
    @Override
    public boolean isSupported(String feature, String version) {
        return false;
    }
    
    @Override
    public String getDocumentBaseURI() {
        return "";
    }
    
    @Override
    public void setDocumentBaseURI(String baseURI) {
    }
    
    @Override
    public String getDocumentSystemIdentifier(int nodeHandle) {
        return null;
    }
    
    @Override
    public String getDocumentEncoding(int nodeHandle) {
        return null;
    }
    
    @Override
    public String getDocumentStandalone(int nodeHandle) {
        return null;
    }
    
    @Override
    public String getDocumentVersion(int documentHandle) {
        return null;
    }
    
    @Override
    public boolean getDocumentAllDeclarationsProcessed() {
        return false;
    }
    
    @Override
    public String getDocumentTypeDeclarationSystemIdentifier() {
        return null;
    }
    
    @Override
    public String getDocumentTypeDeclarationPublicIdentifier() {
        return null;
    }
    
    @Override
    public int getElementById(String elementId) {
        return -1;
    }
    
    @Override
    public boolean supportsPreStripping() {
        return false;
    }
    
    @Override
    public boolean isNodeAfter(int firstNodeHandle, int secondNodeHandle) {
        return this.lessThan(firstNodeHandle, secondNodeHandle);
    }
    
    @Override
    public boolean isCharacterElementContentWhitespace(int nodeHandle) {
        return false;
    }
    
    @Override
    public boolean isDocumentAllDeclarationsProcessed(int documentHandle) {
        return false;
    }
    
    @Override
    public boolean isAttributeSpecified(int attributeHandle) {
        return false;
    }
    
    @Override
    public void dispatchCharactersEvents(int nodeHandle, ContentHandler ch, boolean normalize) throws SAXException {
    }
    
    @Override
    public void dispatchToEvents(int nodeHandle, ContentHandler ch) throws SAXException {
    }
    
    @Override
    public Node getNode(int nodeHandle) {
        return this.makeNode(nodeHandle);
    }
    
    @Override
    public boolean needsTwoThreads() {
        return false;
    }
    
    @Override
    public ContentHandler getContentHandler() {
        return null;
    }
    
    @Override
    public LexicalHandler getLexicalHandler() {
        return null;
    }
    
    @Override
    public EntityResolver getEntityResolver() {
        return null;
    }
    
    @Override
    public DTDHandler getDTDHandler() {
        return null;
    }
    
    @Override
    public ErrorHandler getErrorHandler() {
        return null;
    }
    
    @Override
    public DeclHandler getDeclHandler() {
        return null;
    }
    
    @Override
    public void appendChild(int newChild, boolean clone, boolean cloneDepth) {
    }
    
    @Override
    public void appendTextChild(String str) {
    }
    
    @Override
    public SourceLocator getSourceLocatorFor(int node) {
        return null;
    }
    
    @Override
    public void documentRegistration() {
    }
    
    @Override
    public void documentRelease() {
    }
    
    @Override
    public void migrateTo(DTMManager manager) {
    }
    
    @Override
    public void release() {
        if (this._documentID != 0) {
            this._dtmManager.release(this, true);
            this._documentID = 0;
        }
    }
    
    static {
        EMPTY_ITERATOR = new DTMAxisIteratorBase() {
            @Override
            public DTMAxisIterator reset() {
                return this;
            }
            
            @Override
            public DTMAxisIterator setStartNode(int node) {
                return this;
            }
            
            @Override
            public int next() {
                return -1;
            }
            
            @Override
            public void setMark() {
            }
            
            @Override
            public void gotoMark() {
            }
            
            @Override
            public int getLast() {
                return 0;
            }
            
            @Override
            public int getPosition() {
                return 0;
            }
            
            @Override
            public DTMAxisIterator cloneIterator() {
                return this;
            }
            
            @Override
            public void setRestartable(boolean isRestartable) {
            }
        };
        SimpleResultTreeImpl._documentURIIndex = 0;
    }
    
    public final class SimpleIterator extends DTMAxisIteratorBase
    {
        static final int DIRECTION_UP = 0;
        static final int DIRECTION_DOWN = 1;
        static final int NO_TYPE = -1;
        int _direction;
        int _type;
        int _currentNode;
        
        public SimpleIterator() {
            this._direction = 1;
            this._type = -1;
        }
        
        public SimpleIterator(int direction) {
            this._direction = 1;
            this._type = -1;
            this._direction = direction;
        }
        
        public SimpleIterator(int direction, int type) {
            this._direction = 1;
            this._type = -1;
            this._direction = direction;
            this._type = type;
        }
        
        @Override
        public int next() {
            if (this._direction == 1) {
                while (this._currentNode < 2) {
                    if (this._type != -1) {
                        if ((this._currentNode == 0 && this._type == 0) || (this._currentNode == 1 && this._type == 3)) {
                            return this.returnNode(SimpleResultTreeImpl.this.getNodeHandle(this._currentNode++));
                        }
                        ++this._currentNode;
                    }
                    else {
                        return this.returnNode(SimpleResultTreeImpl.this.getNodeHandle(this._currentNode++));
                    }
                }
                return -1;
            }
            while (this._currentNode >= 0) {
                if (this._type != -1) {
                    if ((this._currentNode == 0 && this._type == 0) || (this._currentNode == 1 && this._type == 3)) {
                        return this.returnNode(SimpleResultTreeImpl.this.getNodeHandle(this._currentNode--));
                    }
                    --this._currentNode;
                }
                else {
                    return this.returnNode(SimpleResultTreeImpl.this.getNodeHandle(this._currentNode--));
                }
            }
            return -1;
        }
        
        @Override
        public DTMAxisIterator setStartNode(int nodeHandle) {
            int nodeID = SimpleResultTreeImpl.this.getNodeIdent(nodeHandle);
            this._startNode = nodeID;
            if (!this._includeSelf && nodeID != -1) {
                if (this._direction == 1) {
                    ++nodeID;
                }
                else if (this._direction == 0) {
                    --nodeID;
                }
            }
            this._currentNode = nodeID;
            return this;
        }
        
        @Override
        public void setMark() {
            this._markedNode = this._currentNode;
        }
        
        @Override
        public void gotoMark() {
            this._currentNode = this._markedNode;
        }
    }
    
    public final class SingletonIterator extends DTMAxisIteratorBase
    {
        static final int NO_TYPE = -1;
        int _type;
        int _currentNode;
        
        public SingletonIterator() {
            this._type = -1;
        }
        
        public SingletonIterator(int type) {
            this._type = -1;
            this._type = type;
        }
        
        @Override
        public void setMark() {
            this._markedNode = this._currentNode;
        }
        
        @Override
        public void gotoMark() {
            this._currentNode = this._markedNode;
        }
        
        @Override
        public DTMAxisIterator setStartNode(int nodeHandle) {
            int nodeIdent = SimpleResultTreeImpl.this.getNodeIdent(nodeHandle);
            this._startNode = nodeIdent;
            this._currentNode = nodeIdent;
            return this;
        }
        
        @Override
        public int next() {
            if (this._currentNode == -1) {
                return -1;
            }
            this._currentNode = -1;
            if (this._type != -1) {
                if ((this._currentNode == 0 && this._type == 0) || (this._currentNode == 1 && this._type == 3)) {
                    return SimpleResultTreeImpl.this.getNodeHandle(this._currentNode);
                }
                return -1;
            }
            else {
                return SimpleResultTreeImpl.this.getNodeHandle(this._currentNode);
            }
        }
    }
}
